/*
 * Copyright (c) 2017, Oracle and/or its affiliates. All rights reserved.
 * ORACLE PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package com.sun.ts.tests.securityapi.idstore.ldapserver;


import com.unboundid.ldap.listener.InMemoryDirectoryServer;
import com.unboundid.ldap.listener.InMemoryDirectoryServerConfig;
import com.unboundid.ldap.listener.InMemoryListenerConfig;
import com.unboundid.ldap.sdk.LDAPException;
import com.unboundid.ldif.LDIFReader;


public class LdapServerSetup {	
	
	public static void main(String[] args) {
		InMemoryDirectoryServer ldapServer = null;
		try{
			InMemoryDirectoryServerConfig config = new InMemoryDirectoryServerConfig("dc=net");
	        config.setListenerConfigs(new InMemoryListenerConfig("LdapForSecurityAPI", null, 11389, null, null, null));
	        ldapServer = new InMemoryDirectoryServer(config);
	        
	        String ldif = System.getProperty("ldif.file");
	        System.out.println("ldif file is:" + ldif);
	        ldapServer.importFromLDIF(true, new LDIFReader(ldif));
	        ldapServer.startListening();
	        System.out.println("Ldap server started...");
		}catch(Exception ex){
			 System.out.println("Exception: " + ex.getMessage());
			 ex.printStackTrace();
			 throw new IllegalStateException(ex);
		}
	}    

}
